var Model;

module.exports = Model = (function() {

  function Model() {}

  Model.hasImage = function(thame, rank) {
    var val;
    val = this.getCount(thame, rank);
    return val > 0;
  };

  Model.openImage = function(thame, rank) {
    var count;
    count = this.getCount(thame, rank);
    count += 1;
    this.setCount(thame, rank, count);
  };

  Model.getCount = function(thame, rank) {
    var val;
    val = Ti.App.Properties.getInt("count." + thame + "." + rank);
    if (val == null) {
      val = 0;
    }
    return val;
  };

  Model.setCount = function(thame, rank, val) {
    Ti.App.Properties.setInt("count." + thame + "." + rank, val);
  };

  Model.isComp = function(thame) {
    var val;
    val = Ti.App.Properties.getBool("comp." + thame);
    if (val == null) {
      val = false;
    }
    return val;
  };

  Model.setComp = function(thame) {
    Ti.App.Properties.setBool("comp." + thame, true);
  };

  Model.getNumberStarts = function() {
    var val;
    val = Ti.App.Properties.getInt("number.starts");
    if (val == null) {
      val = 0;
    }
    return val;
  };

  Model.setNumberStarts = function() {
    var val;
    val = this.getNumberStarts();
    if (val == null) {
      val = 0;
    }
    ++val;
    Ti.App.Properties.setInt("number.starts", val);
  };

  Model.getTotalDrawCardNum = function(thame) {
    var count, i, totalcount, _i;
    totalcount = 0;
    for (i = _i = 1; _i <= 7; i = ++_i) {
      count = this.getCount(thame, i);
      totalcount += count;
    }
    return totalcount;
  };

  Model.checkCompleteNum = function(thame) {
    var compCardNum, i, _i;
    compCardNum = 6;
    for (i = _i = 1; _i <= 6; i = ++_i) {
      if (this.hasImage(thame, i) === true) {
        compCardNum--;
      }
    }
    return compCardNum;
  };

  Model.getLastDrawDate = function(thame, count) {
    return Ti.App.Properties.getString("Draw" + count + "." + thame + ":lastDrawTime") || "000000000000";
  };

  Model.setLastDrawDate = function(thame, count) {
    var nowTime;
    nowTime = this.getDate();
    return Ti.App.Properties.setString("Draw" + count + "." + thame + ":lastDrawTime", nowTime);
  };

  Model.getDate = function() {
    var date, hours, minutes, mounth, nowDate, nowTime, year;
    nowDate = new Date();
    year = nowDate.getFullYear();
    mounth = (nowDate.getMonth() + 1) < 10 ? "0" + (nowDate.getMonth() + 1) : nowDate.getMonth() + 1;
    date = nowDate.getDate() < 10 ? "0" + nowDate.getDate() : nowDate.getDate();
    hours = nowDate.getHours() < 10 ? "0" + nowDate.getHours() : nowDate.getHours();
    minutes = nowDate.getMinutes() < 10 ? "0" + nowDate.getMinutes() : nowDate.getMinutes();
    nowTime = "" + year + mounth + date + hours + minutes;
    return nowTime;
  };

  Model.isDraw = function(thame, count) {
    var time;
    time = this.canDrawTimeLeft(thame, count);
    return time > 0;
  };

  Model.canDrawTimeLeft = function(thame, count) {
    var diffTime, lastTime, nowTime;
    lastTime = this.stringToDate(this.getLastDrawDate(thame, count));
    nowTime = new Date();
    diffTime = (nowTime.getTime() - lastTime.getTime()) / (1000 * 60);
    diffTime = parseInt(diffTime);
    if (count === 1) {
      return diffTime - 15;
    } else if (count === 10) {
      return diffTime - 30;
    }
  };

  Model.stringToDate = function(timestring) {
    var d, h, m, m2, y;
    y = parseInt(timestring.substring(0, 3 + 1), 10);
    m = parseInt(timestring.substring(4, 5 + 1), 10);
    d = parseInt(timestring.substring(6, 7 + 1), 10);
    h = parseInt(timestring.substring(8, 9 + 1), 10);
    m2 = parseInt(timestring.substring(10));
    return new Date(y, m - 1, d, h, m2);
  };

  return Model;

})();
