////////////////////////////////////////////////////////////////////////////////
//
//  CLOUD CREATIVE STUDIOS, INC.
//
//  Copyright (C) 2011-2012 Cloud Creative Studios, Inc.
//  All Rights Reserved.
//
//  http://www.cloud-creative-studios.com
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
///@brief アクティブインジケーター
///
///@note
///Android版では、ActivityIndicatorを使うと、すべての画面の上にオーバーラップして、
///表示を行い、ユーザの入力処理及び画像の表示は行えない。
var ActivityIndicator = {
	
	//--------------------------------------------------------------------------
	///@brief アクティブインジケーターの表示
	///@param [in] message 動作中表示テキスト
	///
	///この関数によって表示したアクティブインジケーターは、
	///ActivityIndicator::close()を呼び出して、
	///意図的に閉じる必要がある。
	open:function(message) {
		this.indicator = Ti.UI.createActivityIndicator({
			top:25, height:50, width:100
		});
		this.window = Ti.UI.createWindow({
			top:0, bottom:0, left:0, right:0
		});
		var baseView = Ti.UI.createView({
			top:200, height:100, width:100,
			borderRadius:10,
			opacity:0.75,
			backgroundColor:"#666"
		});
		baseView.add(this.indicator);
		this.window.add(baseView);
		
		if (ccs.Aux.Platform.isAndroid()) {
			this.indicator.message = message;
		}
		
		this.indicator.show();
		
		if (ccs.Aux.Platform.isIPhone()) {
			this.indicator.color = "black";
			this.indicator.style = Ti.UI.iPhone.ActivityIndicatorStyle.BIG;
			this.window.open();
		}
	},
	
	//--------------------------------------------------------------------------
	///@brief　閉じる
	close:function() {
		if (ccs.Aux.Platform.isIPhone() && !!this.window) {
			this.window.close();
		}
		if (!!this.indicator) {
			this.indicator.hide();
		}
	}
};
