var ApplicationWindow;

module.exports = ApplicationWindow = (function() {

  ApplicationWindow.prototype.layout = {
    animation: {
      width: 320,
      height: 430
    }
  };

  function ApplicationWindow(subWindow) {
    var Admob, Aux, backView, pixelFormat, view;
    this.subWindow = subWindow;
    backView = Ti.UI.createWindow({
      top: 0,
      left: 0,
      height: Ti.UI.FULL,
      width: Ti.UI.FULL,
      backgroundColor: "#000"
    });
    backView.open();
    Aux = require('lib/Aux');
    pixelFormat = Aux.isAndroid() ? Ti.UI.Android.PIXEL_FORMAT_TRANSLUCENT : '';
    this.self = Ti.UI.createWindow({
      backgroundImage: '/images/Background/UI_main-2.jpg',
      windowPixelFormat: pixelFormat,
      width: 320,
      height: 480
    });
    this.addAnimation('gia', 59);
    this.addImage(94, 4);
    this.addImage(184, 5);
    this.addImage(274, 6);
    this.addAnimation('tv', 35);
    this.addThameButton(94, 4);
    this.addThameButton(184, 5);
    this.addThameButton(274, 6);
    this.addPageButton(364);
    Admob = require('lib/Ad/Admob');
    view = new Admob().createAdmobView(false);
    this.self.add(view);
    this.self.open();
  }

  ApplicationWindow.prototype.addAnimation = function(name, count) {
    var Aux, anim, animView, i, num, _i;
    anim = [];
    Aux = require('lib/Aux');
    if (Aux.isIPhone()) {
      for (i = _i = 0; 0 <= count ? _i <= count : _i >= count; i = 0 <= count ? ++_i : --_i) {
        num = '00000' + i;
        anim.push(("/images/Animation/" + name + "/" + name + "_") + num.slice(num.length - 5, num.length) + '.png');
      }
    }
    animView = Ti.UI.createImageView({
      duration: 80,
      repeatCount: 0,
      top: 0,
      left: 0,
      width: this.layout.animation.width,
      height: this.layout.animation.height
    });
    if (Aux.isAndroid()) {
      num = '00000' + 0;
      animView.image = ("/images/Animation/" + name + "/" + name + "_") + num.slice(num.length - 5, num.length) + '.png';
    } else {
      animView.images = anim;
    }
    if (Aux.isIPhone()) {
      animView.addEventListener('load', function() {
        return animView.start();
      });
    }
    return this.self.add(animView);
  };

  ApplicationWindow.prototype.addImage = function(top, thame) {
    return this.self.add(Ti.UI.createImageView({
      top: top,
      left: 38,
      height: 68,
      width: 244,
      image: "/images/Button/Button_Thame0" + thame + ".png"
    }));
  };

  ApplicationWindow.prototype.addThameButton = function(top, thame) {
    var button,
      _this = this;
    button = Ti.UI.createButton({
      top: top,
      left: 38,
      height: 68,
      width: 244,
      backgroundImage: '/images/Button/Button_Thame.png'
    });
    button.addEventListener('click', function() {
      var Aux, Window;
      Window = require('ui/handheld/DrawListWindow.iphone');
      new Window(thame, _this.self);
      Aux = require('lib/Aux');
      if (Aux.isAndroid()) {
        return _this.self.close();
      }
    });
    return this.self.add(button);
  };

  ApplicationWindow.prototype.addPageButton = function(top) {
    var button,
      _this = this;
    button = Ti.UI.createButton({
      top: top,
      left: 140,
      width: 141,
      height: 45,
      backgroundImage: '/images/Button/Button_Back.png'
    });
    button.addEventListener('click', function() {
      _this.subWindow.subWindow = _this.self;
      _this.subWindow.open();
      return _this.self.close();
    });
    return this.self.add(button);
  };

  return ApplicationWindow;

})();
