var DrawListWindow;

module.exports = DrawListWindow = (function() {

  function DrawListWindow(thame, subWindow) {
    var Admob, Aux, backButton, pixelFormat, resultButton, view,
      _this = this;
    this.thame = thame;
    this.subWindow = subWindow;
    thame = this.thame + 1;
    Aux = require('lib/Aux');
    pixelFormat = Aux.isAndroid() ? Ti.UI.Android.PIXEL_FORMAT_TRANSLUCENT : '';
    this.self = Ti.UI.createWindow({
      backgroundImage: "/images/Background/Background0" + thame + ".jpg",
      windowPixelFormat: pixelFormat,
      exitOnClose: false,
      width: 320,
      height: 480
    });
    this.buttonHaveNotYetImg = Aux.isAndroid() ? Ti.Filesystem.getFile(Ti.Filesystem.resourcesDirectory, '/images/Button/Button_HaveNotYet.png') : '/images/Button/Button_HaveNotYet.png';
    this.addDrawButton(64, 1, '/images/Button/Button_Draw1.png');
    this.addDrawButton(113, 10, '/images/Button/Button_Draw10.png');
    this.addCardButton(39, 165, 1);
    this.addCardButton(128, 165, 2);
    this.addCardButton(217, 165, 3);
    this.addCardButton(39, 232, 4);
    this.addCardButton(128, 232, 5);
    this.addCardButton(217, 232, 6);
    this.addCardButton(127, 299, 7);
    backButton = this.addImageButton(39, 370, 141, 45, '/images/Button/Button_Back.png');
    backButton.addEventListener('click', function() {
      var Window;
      Aux = require('lib/Aux');
      if (Aux.isAndroid()) {
        Window = require("ui/handheld/ApplicationWindow");
        _this.subWindow.open();
      }
      return _this.self.close();
    });
    resultButton = this.addImageButton(205, 370, 81, 45, '/images/Button/Button_Result.png');
    resultButton.addEventListener('click', function() {
      var ResultWindow;
      ResultWindow = require('ui/handheld/ResultWindow');
      return new ResultWindow(_this.thame);
    });
    Admob = require('lib/Ad/Admob');
    view = new Admob().createAdmobView();
    this.self.add(view);
    this.self.open();
  }

  DrawListWindow.prototype.addDrawButton = function(top, count, image) {
    var button,
      _this = this;
    button = this.addImageButton(39, top, 141, 45, image);
    return button.addEventListener('click', function() {
      var DrawWindow, Model, alertDialog, time;
      Model = require('model/model');
      time = Model.canDrawTimeLeft(_this.thame, count);
      if (Model.isDraw(_this.thame, count)) {
        Model.setLastDrawDate(_this.thame, count);
        DrawWindow = require('ui/handheld/DrawWindow.iphone');
        return new DrawWindow(_this.thame, count, _this);
      } else {
        if (count === 1) {
          alertDialog = Titanium.UI.createAlertDialog({
            title: Ti.Locale.getString("tweet_cant_now"),
            message: Ti.Locale.getString("tweet_wait_for") + Math.abs(time) + Ti.Locale.getString("tweet_minutes2"),
            buttonNames: [Ti.Locale.getString("tweet_ok")],
            cancel: 1
          });
          return alertDialog.show();
        } else {
          alertDialog = Titanium.UI.createAlertDialog({
            title: Ti.Locale.getString("tweet_cant"),
            message: Ti.Locale.getString("tweet_if") + Math.abs(time) + Ti.Locale.getString("tweet_minutes"),
            buttonNames: [Ti.Locale.getString("tweet_tweet"), Ti.Locale.getString("tweet_no_thanks")],
            cancel: 1
          });
          alertDialog.addEventListener('click', function(event) {
            var indicator, loginHandler, params, successcount;
            if (event.index === 0) {
              Ti.include("/lib/ccs.js", "/lib/ccsAux.js");
              indicator = Titanium.UI.createActivityIndicator({
                message: Ti.Locale.getString("tweet_connecting")
              });
              indicator.show();
              Ti.App.Twitter = {
                ConsumerKey: "PjV9wfdX6DD49mJAq920w",
                ConsumerSecret: "urjLM5ugXWMH08VgmDtOFu5fMFeTLJvkomSRrwx7StY"
              };
              Ti.include('/lib/twitter/Twitter.js');
              ccs.Twitter.init();
              params = {};
              successcount = 1;
              params.success = function() {
                if (successcount === 1) {
                  Model.setLastDrawDate(_this.thame, count);
                  DrawWindow = require('ui/handheld/DrawWindow.iphone');
                  new DrawWindow(_this.thame, count, _this, true);
                  successcount -= 1;
                }
                indicator.hide();
              };
              params.error = function() {
                indicator.hide();
              };
              params.cancel = function() {
                indicator.hide();
              };
              loginHandler = function(e) {
                if (e.success !== void 0) {
                  if (params.success !== void 0) {
                    ccs.Twitter.removeEventListener("login", loginHandler);
                    params.success(ccs.Twitter.getScreenName());
                  }
                } else {
                  if (params.error !== void 0) {
                    params.error();
                  } else if (params.cancel !== void 0) {
                    params.cancel();
                  }
                }
              };
              if (ccs.Twitter.isLoggedIn()) {
                return params.success(ccs.Twitter.getScreenName());
              } else {
                ccs.Twitter.addEventListener("login", loginHandler);
                return ccs.Twitter.login();
              }
            }
          });
          return alertDialog.show();
        }
      }
    });
  };

  DrawListWindow.prototype.addCardButton = function(left, top, rank) {
    var Model, button, image, isGet,
      _this = this;
    Model = require('model/model');
    isGet = Model.hasImage(this.thame, rank);
    image = '';
    if (rank === 7) {
      image = isGet ? "/images/Button/Button_0" + this.thame + "_" + rank + ".png" : '/images/Button/Button_Complete.png';
    } else {
      image = isGet ? "/images/Button/Button_0" + this.thame + "_" + rank + ".png" : this.buttonHaveNotYetImg;
    }
    button = this.addImageButton(left, top, 64, 64, image);
    if (isGet) {
      return button.addEventListener('click', function() {
        var Window, indicator;
        indicator = Titanium.UI.createActivityIndicator({
          message: "Loading..."
        });
        indicator.show();
        Window = require('ui/handheld/ImageDisplayWindow');
        new Window("/images/Thame/0" + _this.thame + "/" + rank + ".jpg");
        return indicator.hide();
      });
    }
  };

  DrawListWindow.prototype.addImageButton = function(left, top, width, height, image) {
    var Aux, button, image1;
    Aux = require('lib/Aux');
    button = Ti.UI.createButton({
      left: left,
      top: top,
      width: width,
      height: height
    });
    if (Aux.isAndroid()) {
      button.backgroundImage = '/images/Button/Button_Thame.png';
      image1 = Ti.UI.createImageView({
        top: top,
        left: left,
        width: width,
        height: height,
        image: image
      });
      this.self.add(image1);
    } else {
      button.image = image;
    }
    this.self.add(button);
    return button;
  };

  return DrawListWindow;

})();
