var ResultWindow;

module.exports = ResultWindow = (function() {

  function ResultWindow(thame) {
    var backButton, bandView, buttonx, buttony, height, i, left, margin_w, screenHeight, screenWidth, scrollView, width, _i,
      _this = this;
    this.thame = thame;
    this.self = Ti.UI.createWindow({
      exitOnClose: false
    });
    screenWidth = Titanium.Platform.displayCaps.platformWidth;
    screenHeight = Titanium.Platform.displayCaps.platformHeight;
    this.fitLeft = screenWidth / 2 - 320 / 2;
    this.fitTop = screenHeight / 2 - 480 / 2;
    this.isiPhone = Ti.Platform.osname === 'iphone';
    this.isAndroid = Ti.Platform.osname === 'android';
    margin_w = 20;
    height = 420;
    width = 320 - margin_w;
    left = margin_w / 2;
    bandView = Ti.UI.createScrollView({
      top: this.isAndroid ? this.fitTop + (480 - 320) / 2 - 25 : (480 - 320) / 2 - 25,
      left: this.isAndroid ? this.fitLeft + left : left,
      height: height,
      width: width,
      contentWidth: 'auto',
      contentHeight: 'auto',
      showVerticalScrollIndicator: true,
      showHorizontalScrollIndicator: true
    });
    this.self.add(bandView);
    scrollView = Ti.UI.createView({
      top: 0,
      left: 0,
      height: height,
      width: width,
      backgroundColor: 'white',
      opacity: 0.8
    });
    bandView.add(scrollView);
    for (i = _i = 1; _i <= 7; i = ++_i) {
      this.createImage(i, bandView);
    }
    this.createTotalNum(bandView);
    this.randomnumber = Math.floor(Math.random() * 100) % 2;
    buttonx = this.isAndroid ? this.fitLeft + 320 / 2 - 140 / 2 : 320 / 2 - 140 / 2;
    buttony = this.isAndroid ? this.fitTop + 425 : 425;
    backButton = this.addImageButton(buttonx, buttony, 140, 45, '/images/Button/Button_Back.png', this.self);
    backButton.addEventListener('click', function() {
      if (_this.randomnumber < 1) {
        _this.self.close();
      } else {
        _this.randomnumber -= 1;
      }
    });
    this.self.open();
  }

  ResultWindow.prototype.createImage = function(rank, bandView) {
    var Model, baseView, cardImage, count, countFontImage, height, left, top, w_num, width;
    Model = require('model/model');
    count = Model.getCount(this.thame, rank);
    if (count == null) {
      count = 0;
    }
    if (count < 1) {
      return;
    }
    w_num = 3;
    height = Math.floor(144 * 6 / 7 + 10);
    width = Math.floor(96 * 6 / 7 + 10);
    top = 15 + height * Math.floor((rank - 1) / w_num);
    left = 30 + (rank - 1) * width - (Math.floor((rank - 1) / w_num) * width * w_num);
    cardImage = Ti.UI.createImageView({
      image: "/images/Thame/0" + this.thame + "/" + rank + ".jpg",
      left: left - 10,
      top: top - 10,
      width: width - 10,
      height: height - 10
    });
    baseView = Ti.UI.createView({
      left: this.isiPhone ? 0 : left - 10,
      top: this.isiPhone ? 40 : 40 + top - 10,
      height: 40,
      width: width - 10,
      backgroundColor: 'black',
      opacity: 0.5
    });
    countFontImage = Ti.UI.createLabel({
      color: '#FFF',
      shadowColor: '#000',
      shadowOffset: {
        x: 3,
        y: 3
      },
      text: " " + count,
      font: {
        fontSize: 24,
        fontFamily: 'Helvetica Neue'
      },
      fontWeight: 'bold',
      textAlign: 'center',
      left: this.isiPhone ? 0 : left - 10,
      top: this.isiPhone ? 40 : 40 + top - 10,
      width: 'auto'
    });
    if (this.isiPhone) {
      cardImage.add(baseView);
      cardImage.add(countFontImage);
      bandView.add(cardImage);
    } else if (this.isAndroid) {
      bandView.add(cardImage);
      bandView.add(baseView);
      bandView.add(countFontImage);
    }
  };

  ResultWindow.prototype.createTotalNum = function(bandView) {
    var Model, baseView, cardImage, count, countFontImage, height, i, left, rank, top, totalcount, w_num, width, _i;
    Model = require('model/model');
    totalcount = 0;
    for (i = _i = 1; _i <= 7; i = ++_i) {
      count = Model.getCount(this.thame, i);
      if (count == null) {
        count = 0;
      }
      totalcount += count;
    }
    rank = 7;
    w_num = 3;
    height = Math.floor(144 * 6 / 7 + 10);
    width = Math.floor(96 * 6 / 7 + 10);
    top = 30 + height * Math.floor((rank - 1) / w_num);
    left = 30 + (rank - 1) * width - (Math.floor((rank - 1) / w_num) * width * w_num) + width;
    width = 488 / 3;
    height = 136 / 3;
    cardImage = Ti.UI.createImageView({
      image: "/images/Button/Button_Thame0" + this.thame + ".png",
      left: left - 10,
      top: top - 10,
      width: width,
      height: height
    });
    baseView = Ti.UI.createView({
      width: width,
      height: height,
      backgroundColor: 'black',
      opacity: 0.5,
      left: this.isiPhone ? 0 : left - 10,
      top: this.isiPhone ? 0 : top - 10
    });
    countFontImage = Ti.UI.createLabel({
      color: '#F00',
      shadowColor: '#FFF',
      shadowOffset: {
        x: 1,
        y: 1
      },
      text: " " + totalcount,
      font: {
        fontSize: 24,
        fontFamily: 'Helvetica Neue'
      },
      fontWeight: 'bold',
      textAlign: 'center',
      left: this.isiPhone ? 0 : left - 10,
      top: this.isiPhone ? 0 : top - 10,
      width: 'auto'
    });
    if (this.isiPhone) {
      cardImage.add(baseView);
      cardImage.add(countFontImage);
      bandView.add(cardImage);
    } else if (this.isAndroid) {
      bandView.add(cardImage);
      bandView.add(baseView);
      bandView.add(countFontImage);
    }
  };

  ResultWindow.prototype.addImageButton = function(left, top, width, height, image, baseView) {
    var Aux, button;
    button = Ti.UI.createButton({
      left: left,
      top: top,
      width: width,
      height: height
    });
    Aux = require('lib/Aux');
    if (Aux.isAndroid()) {
      button.backgroundImage = '/images/Button/Button_Thame.png';
      image = Ti.UI.createImageView({
        top: top,
        left: left,
        width: width,
        height: height,
        image: image
      });
      baseView.add(image);
    } else {
      button.image = image;
    }
    baseView.add(button);
    return button;
  };

  return ResultWindow;

})();
