////////////////////////////////////////////////////////////////////////////////
//
//  CLOUD CREATIVE STUDIOS, INC.
//
//  Copyright (C) 2011-2012 Cloud Creative Studios, Inc.
//  All Rights Reserved.
//
//  http://cloud-creative-studios.com
//
////////////////////////////////////////////////////////////////////////////////

Helen = {};
Helen.app = {};

(function() {

	var Default_Row_Height = 40;
	var Section_Row_Height = 35;

	//--------------------------------------------------------------------------
	///@brief 本アプリでのTwitterログイン
	///@params [in] params.success ログイン完了時の動作
	///@p	本アプリではTwitterログインだけで終わるということはなく
	///		リスト作成や、取得を行う必要がある。
	Helen.app.twitterLogin = function(params) {
		//Twitterに既にリストがあるかどうか。ないときだけリストを作成する
		var showTwitterList = function() {
			TestFlight.passCheckpoint("Helen.app.twitterLogin: showTwitterList");
			var deferred = new Deferred();
			ccs.Twitter.showList({
				slug:Helen.config.Twitter.DefaultListName.toLowerCase(),
				success:function(e) {
					Helen.app.updateFavoliteList();
					//既に存在する場合は、successを返す。
					//存在した場合は、リストを作らないので何もしない
					ActivityIndicator.close();
				},
				error:function(e) {
					//フォルダ名が存在しないときはerrorを返すので作成のステップに進ませる
					deferred.call();
				}
			});
			return deferred;
		};
		//リスト作成
		var createTwitterList = function() {
			TestFlight.passCheckpoint("Helen.app.twitterLogin: createTwitterList");
			var deferred = new Deferred();
			ccs.Twitter.createList({
				name:Helen.config.Twitter.DefaultListName,
				mode:"public",
				description:Helen.config.Twitter.DefaultListDiscription,
				success:function(e) {
					deferred.call();
				},
				error:function(e) {
					//作れなかったときは、パラメータ不正かリストが20件作られているかの時。
					//パラメータは固定で、認証済みの時にしかよばないので、
					//基本的にエラーになるのはリストが最大数を超えているというときだけ
					ActivityIndicator.close();
					Helen.app.showErrorDialog(
						"アプリで使用するリストを作成できませんでした。\nアプリからお気に入り登録ができません。",
						function() {}
					);
				}
			});
			return deferred;
		};
		var loginHandler = function(e) {
			TestFlight.passCheckpoint("Helen.app.twitterLogin: Twitter login");
			ccs.Twitter.removeEventListener("login", loginHandler)
			if (e.success != undefined) {
				if (params.success != undefined) {
					params.success(ccs.Twitter.getScreenName());
				}
				
				//認証後、リストを作成する
				next(function() {
					return showTwitterList();
				}).next(function() {
					return createTwitterList();
				}).next(function() {
					ActivityIndicator.close();
				});
			} else {
				ActivityIndicator.close();
			}
		};
		ccs.Twitter.addEventListener("login", loginHandler);
		ActivityIndicator.open("接続中");
		ccs.Twitter.login();
	};

	//--------------------------------------------------------------------------
	///@biref ツイートする
	///@param [in] params Twitterのstatus/updateパラメータ
	///@param [in] callbackHandler 投稿完了時のコールバック関数
	///@param [in] isAutoTweet 自動つぶやきかどうか
	Helen.app.tweet = function(params, callbackHandler, isAutoTweet) {
/*		if (!!isAutoTweet && !!tweetVisible) {
			//自動つぶやきで、既に制限時間内につぶやいた後なら、つぶやけない
			return;
		}
		//自動つぶやきのときに、ツイートフラグが降りていたらフラグを更新する
		if (!!isAutoTweet && !tweetVisible) {
			updateTweetTimer();
		}*/
		var getCurrentPosition = function(callback) {
			var deferred = new Deferred();
			Ti.Geolocation.accuracy = Ti.Geolocation.ACCURACY_BEST;
			Ti.Geolocation.purpose = "つぶやきに位置情報を設定します。";
			Ti.Geolocation.getCurrentPosition(function(e) {
				// Twitterに指定する位置情報は浮動小数点以下第8位までしか対応していない
				// 関数名はいいのが思いつかなかった…
				var decimal = function(val) {
					var v = String(val).split(".");
					return v[0] + "." + v[1].substr(0, 8);
				};
				callback({
					latitude:decimal(e.coords.latitude),
					longitude:decimal(e.coords.longitude)
				});
				e.error == undefined ? deferred.call() : deferred.fail();
			});
			return deferred;
		};
		
		var Model = require('model/model');
		if (!!Model.isEnabledGeolocation()) {
//			TestFlight.passCheckpoint("位置情報付きのつぶやき");
			var coords = {};
			next(function() {
				return getCurrentPosition(function(e) {
					coords.latitude = e.latitude;
					coords.longitude = e.longitude;
				});
			}).next(function() {
				if (coords != undefined) {
					params.lat = coords.latitude;
					params.long = coords.longitude;
					
					//今回の位置情報から、移動距離を取得する
					var pos = Helen.model.getLocationPoint();
					if (pos.lat != undefined && pos.long != undefined) {
						TestFlight.passCheckpoint("メダルのために位置情報から距離を保存");
						
						//paramsを渡すと参照渡しになるので、現在の位置を変数として定義
						var nowPos = {
							lat:params.lat,
							long:params.long
						};
						Helen.model.setRangeCount(Number(Helen.model.getRangeCount()) + Number(geoDistance(nowPos, pos)));
						ccs.DebugLog("距離(m) : " + Helen.model.getRangeCount());
						//移動距離を算出して、保存する
						Helen.Medal.checkLocationRange(Helen.model.getRangeCount());
					}
					
					//今回の位置情報を保存する
					Helen.model.setLocationPoint({
						lat:params.lat,
						long:params.long
					});
				}
				ccs.Twitter.tweet(params, callbackHandler);
			});
		} else {
//			TestFlight.passCheckpoint("位置情報無しのつぶやき");
			ccs.Twitter.tweet(params, callbackHandler);
		}
	};
}());
