////////////////////////////////////////////////////////////////////////////////
//
//  CLOUD CREATIVE STUDIOS, INC.
//
//  Copyright (C) 2011-2012 Cloud Creative Studios, Inc.
//  All Rights Reserved.
//
//  http://cloud-creative-studios.com
//
////////////////////////////////////////////////////////////////////////////////

Helen = {};
Helen.app = {};
Helen.ui = {};
Helen.config = {};

(function() {
	
	Helen.config.App = {};
	Helen.config.App.Name = "Cockatoo";
	Helen.config.App.URL = "http://goo.gl/aJVYT"; //< App Store URL
	Helen.config.PrivacyPolicyURL = "http://cloud-creative-studios.com/Cockatoo/policy.html";
	
	Helen.config.Retry = 4; ///< リトライ回数
	Helen.config.Timeout = 20 * 1000; ///< ネットワークアクセスのタイムアウト時間
	
	Helen.config.UI = {};
	Helen.config.UI.TextColor = "white";
	Helen.config.UI.SubTextColor = "#ccc";
	Helen.config.UI.TimelineTextColor = "#ccc"; ///< Twitterのタイムラインテキスト
	Helen.config.UI.BackgroundColor = "black";
	//試聴で現在再生中の背景色
	Helen.config.UI.PlayerSelectedBackgroundColor = "Orange";
	//お気に入りリストに登録済みの曲の背景色
	Helen.config.UI.FavoriteSongBackgroundColor = "#006400";
	//曲情報画面の移動スピード
	Helen.config.UI.MusicInfoAnimationDuration = 500;
	//デーブル更新のviewの高さ
	Helen.config.UI.TableHeaderHeight = 40;
	Helen.config.UI.TableUpdatePullHeight = 20;
	
	Helen.config.Font = {};
	Helen.config.Font.Large = "26px";
	Helen.config.Font.Medium = "16px";
	Helen.config.Font.XSmall = "14px";
	Helen.config.Font.Small = "12px";
	
	Helen.config.Debug = {};
	Helen.config.Debug.Border = 0;
	Helen.config.Debug.BorderColor = Helen.config.Debug.Border == 0 ? "transparent" : "red";
	Helen.config.Debug.BorderColor1 = Helen.config.Debug.Border == 0 ? "transparent" : "blue";
	Helen.config.Debug.BorderColor2 = Helen.config.Debug.Border == 0 ? "transparent" : "green";
	Helen.config.Debug.BorderColor3 = Helen.config.Debug.Border == 0 ? "transparent" : "yellow";
	
	Helen.config.Support = {};
	Helen.config.Support.Website = "http://182.48.46.104/helen";
	Helen.config.Support.Twitter = "https://twitter.com/#!/Cockatoo0";
	Helen.config.Support.Facebook = "https://www.facebook.com/pages/Cockatoo/291577967576789";
	
	Helen.config.Player = {};
	Helen.config.Player.ControlShowTime = 5000; ///< コントロールの表示時間
	Helen.config.Player.UpdatePlaybackInterval = 800; ///< 再生時間の更新タイミング
	Helen.config.Player.CheckPlayEndInterval = 1000;
	Helen.config.Player.BufferSize = 4096; ///< 試聴時のストリーミング再生のバッファサイズ。
	Helen.config.Player.ListenerCountTime = 3 * 24 * 60 * 60; ///< 試聴人数をカウントするときのボーダー時間(秒)
	Helen.config.Player.PreviewSongsSaveMaxCount = 100; ///< 試聴曲を保存できる個数
	Helen.config.Player.TimeLineUpdateDelayTime = 1.5 * 1000; ///< 試聴曲再生後のタイムライン更新を遅らせる時間
	Helen.config.Player.DefaultBufferingCount = 10; ///< バッファリング状態が続いて、再生を止めてしまうまでの回数
	Helen.config.Player.BufferingLevelList = ["すぐ停止", "少し頑張る", "諦めない"]; ///< 再生を止めるまでのレベル
	Helen.config.Player.BufferingCountList = [3, 10, 999]; ///< 再生を止めるまでのレベル
	Helen.config.Player.BufferingCountCheckInterval = 2 * 1000; ///< 再生を止めるためにバッファ状態の回数チェックする時間
	Helen.config.Player.BufferingCountUpInterval = 1 * 1000; ///< バッファ状態の回数を増やすする時間（バッファ中が長い時に対応）
	Helen.config.Player.PreviewCountDelayTime = 5 * 1000; ///< 試聴再生から回数を増やすまで遅らせる時間
	
	Helen.config.Twitter = {};
	Helen.config.Twitter.DefaultTemplate = "\"[title]\" by [artist] on album \"[albumTitle]\"";
	Helen.config.Twitter.DefaultHashtag = "#NowPlaying";
	Helen.config.Twitter.DefaultAppHashtag = "#" + Helen.config.App.Name;
	Helen.config.Twitter.DefaultListName = Helen.config.App.Name; ///< Twitterのリスト名は#を先頭に持ってこれない
	Helen.config.Twitter.DefaultListDiscription = Helen.config.App.Name + "のお気に入り一覧";
	Helen.config.Twitter.DefaultTweetIntervalTime = 2 * 60 * 1000; ///< つぶやく時間の間隔(秒)
	Helen.config.Twitter.TweetIntervalList = [2,5,10];///< つぶやく時間の間隔(分)
	
	Helen.config.Twitter.DefaultTweetStringNum = 140;
	Helen.config.Twitter.HashtagTweetStringNum = 110;///< 140 -  (アプリURLとアプリ名のハッシュタグの30文字)
	
	Helen.config.Twitter.ZeroTweet = "つぶやきが見つかりませんでした";
}());